//+------------------------------------------------------------------+
//|                                                       Suback.mqh |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#include "MQTT.mqh"
#include "IControlPacket.mqh"

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CSuback : public IControlPacket
  {
private:
   bool              IsControlPacket() {return true;}

public:
                     CSuback();
                    ~CSuback();
   static bool       IsSuback(uchar &inpkt[]);
   string            ReadReasonString(uchar &inpkt[], uint idx);
   void              ReadPayload(uchar &inpkt[], uchar &dest_buf[]);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CSuback::ReadPayload(uchar &inpkt[], uchar &dest_buf[])
  {
   ArrayCopy(dest_buf, inpkt);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string CSuback::ReadReasonString(uchar &inpkt[], uint idx)
  {
   return ReadUtf8String(inpkt, idx);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
static bool CSuback::IsSuback(uchar &inpkt[])
  {
   return inpkt[0] == (SUBACK << 4) ? true : false;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CSuback::CSuback()
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CSuback::~CSuback()
  {
  }
//+------------------------------------------------------------------+
